<?php
/*
Plugin Name: Filosofo Google Ad Sectioning
Plugin URI: http://www.ilfilosofo.com/blog/2006/11/14/google-adsense-targeting/
Description: Uses Google's <a href="https://www.google.com/adsense/support/bin/answer.py?answer=23168&ctx=en:search&query=section+targeting&topic=&type=f">section targeting</a> to make the content of your Google ads more relevant.    
Version: 1.0
Author: Austin Matzko
Author URI: http://www.ilfilosofo.com/blog/
*/

/*  Copyright 2006  Austin Matzko  (email : if.website at gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

class filosofo_google_ad_sectioning {

	function filosofo_google_ad_sectioning() {
		$this->open_inc = '<!-- google_ad_section_start -->';
		$this->open_ign = '<!-- google_ad_section_start(weight=ignore) -->';
		$this->close = '<!-- google_ad_section_end -->';

		// ad sections
		add_filter('get_comment_text',array(&$this,'included'),99);
		add_filter('the_content',array(&$this,'included'),99);

		// ad exclusions
		add_filter('get_comment_excerpt',array(&$this,'excluded'),99);
		add_filter('list_cats',array(&$this,'excluded'),99);
		add_filter('loginout',array(&$this,'excluded'),99);
		add_filter('register',array(&$this,'excluded'),99);
		add_filter('the_excerpt',array(&$this,'excluded'),99);
		add_filter('wp_list_pages',array(&$this,'excluded'),99);

		// remove the markup
		add_filter('the_content_rss',array(&$this,'scrub'),99);
		add_filter('the_excerpt_rss',array(&$this,'scrub'),99);

	}

	function included( $text = '' ) {
		$text = $this->scrub( $text );
		if ( $this->no_tags() ) return $text;
		return $this->open_inc . $text . $this->close;
	}

	function excluded( $text = '' ) {
		$text = $this->scrub( $text );
		if ( $this->no_tags() ) return $text;
		return $this->open_ign . $text . $this->close;
	}

	function scrub( $text = '' ) {
		$text = str_replace($this->open_inc,'',$text);
		$text = str_replace($this->open_ign,'',$text);
		$text = str_replace($this->close,'',$text);
		return $text;
	}

	function no_tags() {
		$qv = get_query_var('feed');
		if ( ! '' == $qv ) return true;
		else return false;
	}

} // end class

$filosofo_google_ad_sectioning = new filosofo_google_ad_sectioning();

?>
